var servercount = 0;
var javaEnabled = 0;
var javaVersion = "";
var browser = "";
var platform = "";
var availableFWVersion = "";

var constwidth = 510;
var constheight = 160;
var tablewidth = 0;
var windowWidth = 0;
var windowHeight = 0;

var wshShell = null;
function nasdiscoveryload() {
    servercount = 0;
    javaEnabled = 0;

    // initialize EVENT handlers
    addEvent(window, "resize", resizewindow);

    // get the browser details
    getBrowserDetails();

    // get the present window size
    getWindowsSize();

    if(browser != "IE") {
    	constheight = 188;
    	constwidth = 585;
    }
	
    if(browser == "IE") {
        // Get information about the installed JRE
        getInstalledJREInfo();
    }

    // create Header Table dynamically
    document.write("<DIV id=\"divHeader\">");
    document.write("<TABLE id=\"Header\" cellSpacing=0 cellPadding=0 width=\"100%\" border=0 rowSpan=2>");
    document.write("<tr>");
    document.write("<td width=140>");
    document.write("<img src=\"images/header_logo.jpg\" alt=\"NAS Systems\" border=0></a>");
    document.write("</td>");
    document.write("<td><img src=\"images/head_filler.jpg\" width=100% height=102></td>");
    document.write("<td width=561><img src=\"images/header_right.jpg\"></td>");
    document.write("</tr>");
    document.write("</TABLE>");
    document.write("</DIV>");

    document.write("<DIV id=\"divInfoHeader\">");
    document.write("<TABLE id=\"InfoHdr\" cellSpacing=0 cellPadding=0 width=\"100%\" border=0 rowSpan=2>");
    document.write("<tr>");
    document.write("<td height=56 colspan=3><img src=\"images/header_title.jpg\" border=0></td>");
    document.write("</tr>");
    document.write("</TABLE>");
    document.write("</DIV>");

    if(javaVersion != "" && isPreferredJREInstalled() == 0) {
        displayJREVersionMismatchError();
    }
    else if(javaEnabled == 1) {
        document.write("<DIV class=\"tableContainer\" id=\"tableContainer\"></DIV>");
        document.write("<APPLET ");
        document.write("NAME='NASDiscoveryApp' CODEBASE='.' CODE='NASDiscovery.class' ARCHIVE='NASDiscovery.jar,swing-layout-1.0.jar,netscape-javascript.jar' WIDTH=0 HEIGHT=0 BORDER=0 MAYSCRIPT style=\"visibility:hidden\">");
        document.write("</APPLET>");

        // build the table with fixed header and tbody element
        buildServerInfoTable();
    }
    else if(javaEnabled == 0) {
        displayJRENotInstalledError();
    }

    // create Footer table dynamically
    document.write("<DIV id=\"divFooter\">");
//    document.write("?007 LSI Corporation. All rights reserved. <a href=\"http://www.lsi.com/cm/ContactSearch.do\" target=\"_blank\">Contact LSI</a>");
    document.write("</DIV>");
}

function addEvent(elm, evType, fn, useCapture) {
    if(elm.addEventListener) {
        elm.addEventListener(evType, fn, useCapture);
        return true;
    }
    else if(elm.attachEvent) {
        var r = elm.attachEvent("on"+evType, fn);
        return r;
    }
    else {
    }
}

function getBrowserDetails() {
    javaEnabled = 0;
    browser = "";
	platform = "";

	// get the user-agent
	var userAgent = navigator.userAgent.toLowerCase();
	if(findString(userAgent, 'konqueror'))			browser = "Konqueror";
	else if(findString(userAgent, 'msie'))			browser = "IE";
	else if(findString(userAgent, 'safari')) 		browser = "Safari";
	else if(findString(userAgent, 'opera')) 		browser = "Opera";
	else if(findString(userAgent, 'icab')) 			browser = "iCab";
	else if(findString(userAgent, 'firefox')) 		browser = "Firefox";
	else if(!findString(userAgent, 'compatible')) 	browser = "Netscape";
	else browser = "unknown";
	
	if(browser == "Konqueror")				platform = "Linux";
	else if(findString(userAgent, 'linux')) platform = "Linux";
	else if(findString(userAgent, 'x11')) 	platform = "Unix";
	else if(findString(userAgent, 'mac')) 	platform = "Mac";
	else if(findString(userAgent, 'win')) 	platform = "Windows";
	else platform = "unknown";

	try {
		if(navigator.javaEnabled() == true) {
			javaEnabled = 1;
        	javaVersion = java.lang.System.getProperty("java.version");
		}
	}
	catch(e) {
	}
}

function getWindowsSize() {
    windowWidth = 0;
    windowHeight = 0;

    if(self.innerWidth) {
        windowWidth = self.innerWidth;
        windowHeight = self.innerHeight;
    }
    else if(document.documentElement && document.documentElement.clientWidth) {
        windowWidth = document.documentElement.clientWidth;
        windowHeight = document.documentElement.clientHeight;
    }
    else if(document.body) {
        windowWidth = document.body.clientWidth;
        windowHeight = document.body.clientHeight;
    }
    else return;
}

function getInstalledJREInfo() {
    var regval = "";
    // Read JRE version from Window Registry
    try {
        var str = "";

        wshShell = new ActiveXObject("WScript.Shell");
        if(wshShell == null)
            return;

        regval = wshShell.regRead("HKEY_LOCAL_MACHINE\\Software\\JavaSoft\\Java Runtime Environment\\CurrentVersion");
        if(regval == "")
            return;
        javaVersion = parseFloat(regval);

        regval = wshShell.regRead("HKEY_LOCAL_MACHINE\\Software\\JavaSoft\\Java Runtime Environment\\" + regval + "\\JavaHome");
        if(regval == "")
            return;

        regval = regval.substring(regval.lastIndexOf("\\") + 1, regval.length);
        if(regval == "")
            return;
        str = regval.substring(0,3);
        if(str == "jre" || str == "JRE")
            regval = regval.substring(3, regval.length);
        else {
            str = regval.substring(0,4);
            if(str == "j2re" || str == "J2RE")
                regval = regval.substring(4, regval.length);
        }
        javaVersion = regval;

        regval = wshShell.regRead("HKEY_LOCAL_MACHINE\\Software\\JavaSoft\\Java Plug-in\\" + regval + "\\UseJava2IExplorer");
        if(regval == "")
            return;

        javaEnabled = parseInt(regval);
    } catch(e) {
    }
}

function displayJRENotInstalledError() {
    document.write("<DIV id=\"divJREErrorInfo\">");
    document.write("<TABLE width=\"480px\">");

    document.write("<tr><td style=\"border-top: 1px solid #2754d3; border-bottom: 1px solid #2754d3; padding: 2px;\">");
    document.write("<font color=\"#2754d3\" size=\"3\"><b>Error</b></font>");
    document.write("</td></tr>");
    document.write("<tr><td>");
    document.write("<P align=\"justify\">");
    document.write("<font color=\"red\" size=\"2\"><b>Failed to start NAS Discovery service.&nbsp;</b></font>");
    document.write("</P>");
    document.write("</td></tr>");
    document.write("<tr /><td />");
    document.write("<tr /><td />");
    document.write("<tr /><td />");

    document.write("<tr><td style=\"border-top: 1px solid #2754d3; border-bottom: 1px solid #2754d3; padding: 2px;\">");
    document.write("<font color=\"#2754d3\" size=\"3\"><b>Reason</b></font>");
    document.write("</td></tr>");
    document.write("<tr><td>");
    document.write("<P align=\"justify\">");
    if(browser == "IE") {
        if(javaVersion == "") {
            document.write("<font color=\"red\" size=\"2\"><b>Java Runtime Environment (JRE) is not installed in this computer.&nbsp;</b></font>");
            document.write("<font color=\"#658ede\" size=\"2\"><b>To run this NASDiscovery Utility, Java Runtime Environment (JRE) 5.0 or higher is required.</b></font>");
        }
        else {
            document.write("<font color=\"red\" size=\"2\"><b>Java Runtime Environment (JRE) is not Enabled in this web browser.&nbsp;</b></font>");
            document.write("<font color=\"#658ede\" size=\"2\"><b>To run this NASDiscovery Utility, Java Runtime Environment (JRE) should be enabled in this web browser.</b></font>");
        }
    }
    else {
        document.write("<font color=\"red\" size=\"2\"><b>Java Runtime Environment (JRE) is not installed in this computer&nbsp;");
        document.write("or not enabled in this web browser.&nbsp;</b></font>");
        document.write("<font color=\"#658ede\" size=\"2\"><b>To run this NASDiscovery Utility, Java Runtime Environment (JRE) 5.0 or higher is required and enabled.</b></font>");
    }
    document.write("</P>");
    document.write("</td></tr>");
    document.write("<tr /><td />");
    document.write("<tr /><td />");
    document.write("<tr /><td />");

    document.write("<tr><td style=\"border-top: 1px solid #2754d3; border-bottom: 1px solid #2754d3; padding: 2px;\">");
    document.write("<font color=\"#2754d3\" size=\"3\"><b>Solution</b></font>");
    document.write("</td></tr>");
    if(browser == "IE") {
        document.write("<tr><td>");
        document.write("<P align=\"justify\">");
        if(javaVersion == "") {
            document.write("<font color=\"red\" size=\"2\"><b>Auto Installation of Java Runtime Environment (JRE) will start soon.&nbsp;</b></font>");
            document.write("<font color=\"#658ede\" size=\"2\"><b>After Installing JRE, refresh NASDiscovery page to start NAS Discovery service.&nbsp;</b></font>");

            // create HTML OBJECT element to invoke Auto_Installation feature
            document.write("<OBJECT ");
            document.write("codeBase=http://java.sun.com/update/1.5.0/jinstall-1_5_0_09-windows-i586.cab classid=clsid:5852F5ED-8BF4-11D4-A245-0080C6F74284 height=0 width=0 style=\"visibility:hidden\">");
            document.write("</OBJECT>");
        }
        else {
            document.write("<font color=\"red\" size=\"2\"><b>Enable Java through your web browser.<br></b></font>");
            document.write("<font color=\"#658ede\" size=\"2\"><b><ol>");
            document.write("<li>Click Tools &gt; Internet Options from the browser menu.");
            document.write("</li><li>Select the Advanced Tab, and scroll down to \"Java (Sun)\"");
            document.write("</li><li>Check the box labled \"Use JRE 1.5.x for &lt;applet&gt;\"");
            document.write("</li><li>Next, select the Security Tab, and select the \"Custom Level\" button");
            document.write("</li><li>Scroll down to \"Scripting of Java applets\"");
            document.write("</li><li>Make sure the \"Enable\" radio button is checked.");
            document.write("</li><li>Click OK to save your preference.");
            document.write("</li></ol></font>");
            document.write("<font color=\"#658ede\" size=\"2\"><b>After Enable Java, refresh NASDiscovery page to start NAS Discovery service.&nbsp;</b></font>");
        }
        document.write("</P>");
        document.write("</td></tr>");
    }
    else {
        sURL = "http://www.java.com/en/download/manual.jsp";

        document.write("<tr><td>");
        document.write("<P align=\"justify\">");
        document.write("<font color=\"red\" size=\"2\"><b>1. Install Java Runtime Environment (JRE) manually, if JRE is not installed already.<br><br></b></font>");
        document.write("<font color=\"#658ede\" size=\"2\" face=\"Arial\"><b><a style=\"color: red\" href=\"http://www.java.com/en/download/manual.jsp\">Click to Download & Install JRE.</a>");
        document.write("&nbsp;You will be redirected to Java Software Manual Download Page, which will guide you to download & install latest Java Runtime Environment (JRE).&nbsp;<br><br></b></font>");

        document.write("<font color=\"red\" size=\"2\"><b>2. Enable Java through your web browser, if JRE is already installed.<br></b></font>");
        document.write("<font color=\"#658ede\" size=\"2\"><b><ol>");
        document.write("<li>Select Tools &gt; Options from the browser menu.</li>");
        document.write("<li>Dialog box: Content tab</li>");
        document.write("<li>Check the box labled \"Enable Java\".</li></ol></b></font>");

        document.write("<font color=\"#658ede\" size=\"2\" face=\"Arial\"><b><br>After Install/Enable Java, close the borwser and open it again to start NAS Discovery service.&nbsp;</b></font>");
        document.write("</P>");
        document.write("</td></tr>");
    }
    document.write("</TABLE>");
    document.write("</DIV>");
}

function displayJREVersionMismatchError() {
    document.write("<DIV id=\"divJREErrorInfo\">");
    document.write("<TABLE width=\"480px\">");

    document.write("<tr><td style=\"border-top: 1px solid #2754d3; border-bottom: 1px solid #2754d3; padding: 2px;\">");
    document.write("<font color=\"#2754d3\" size=\"3\"><b>Error</b></font>");
    document.write("</td></tr>");

    document.write("<tr><td>");
    document.write("<P align=\"justify\">");
    document.write("<font color=\"red\" size=\"2\"><b>Failed to start NAS Discovery service.&nbsp;</b></font>");
    document.write("</P>");
    document.write("</td></tr>");

    document.write("<tr /><td />");
    document.write("<tr /><td />");
    document.write("<tr /><td />");

    document.write("<tr><td style=\"border-top: 1px solid #2754d3; border-bottom: 1px solid #2754d3; padding: 2px;\">");
    document.write("<font color=\"#2754d3\" size=\"3\"><b>Reason</b></font>");
    document.write("</td></tr>");

    document.write("<tr><td>");
    document.write("<P align=\"justify\">");
    document.write("<font color=\"red\" size=\"2\"><b>Java 2 Platform, JRE v " + javaVersion + " is installed in this computer.&nbsp;</b></font>");
    document.write("<font color=\"#658ede\" size=\"2\"><b>To run this NASDiscovery Utility, Java Runtime Environment (JRE) 5.0 or higher is required.</b></font>");
    document.write("</P>");
    document.write("</td></tr>");

    document.write("<tr /><td />");
    document.write("<tr /><td />");
    document.write("<tr /><td />");

    document.write("<tr><td style=\"border-top: 1px solid #2754d3; border-bottom: 1px solid #2754d3; padding: 2px;\">");
    document.write("<font color=\"#2754d3\" size=\"3\"><b>Solution</b></font>");
    document.write("</td></tr>");

    if(browser == "IE") {
        document.write("<tr><td>");
        document.write("<P align=\"justify\">");
        document.write("<font color=\"red\" size=\"2\"><b>Auto Installation of Java Runtime Environment (JRE), v 1.5.0.09 will start soon.&nbsp;</b></font>");
        document.write("<font color=\"#658ede\" size=\"2\"><b>After Installing JRE, refresh NASDiscovery page to start NAS Discovery service.&nbsp;</b></font>");

        // create HTML OBJECT element to invoke Auto_Installation feature
        document.write("<OBJECT ");
        document.write("codeBase=http://java.sun.com/update/1.5.0/jinstall-1_5_0_09-windows-i586.cab classid=clsid:5852F5ED-8BF4-11D4-A245-0080C6F74284 height=0 width=0 style=\"visibility:hidden\">");
        document.write("</OBJECT>");

        document.write("</P>");
        document.write("</td></tr>");
    }
    else {
        sURL = "http://www.java.com/en/download/manual.jsp";

        document.write("<tr><td>");
        document.write("<P align=\"justify\">");
        document.write("<font color=\"red\" size=\"2\"><b>Install latest Java Runtime Environment (JRE) manually.<br><br></b></font>");
        document.write("<font color=\"#658ede\" size=\"2\" face=\"Arial\"><b>");
        document.write("<a style=\"color: red\" href=\"http://www.java.com/en/download/manual.jsp\">Click to Download & Install JRE.</a>");
        document.write("&nbsp;You will be redirected to Java Software Manual Download Page, which will guide you to download & install latest Java Runtime Environment (JRE).&nbsp;<br>");
        document.write("</b></font>");
        document.write("<font color=\"#658ede\" size=\"2\" face=\"Arial\"><b><br>After Install Java, close the borwser and open it again to start NAS Discovery service.&nbsp;</b></font>");
        document.write("</P>");
        document.write("</td></tr>");
    }
    document.write("</TABLE>");
    document.write("</DIV>");
}

function isPreferredJREInstalled() {
    if(parseFloat(javaVersion.substring(0, 3)) < 1.5) {
        return 0;
    }
    return 1;
}

function resizewindow() {
    // get the present window size
    getWindowsSize();

    divs = document.getElementsByTagName("DIV");
    for(i = 0; i < divs.length; i++) {
        if(((' '+divs[i].className+' ').indexOf("tableContainer") != -1)) {
            if(browser == "IE") {
                divs[i].style.height = (windowHeight - constheight) + "px";
            }

            // calculate new div width
            tablewidth = windowWidth - constwidth;

            // Take object table and get all it's tbodies.
            tbls = divs[i].getElementsByTagName("table");
            for(ti = 0; ti < tbls.length; ti++) {
                if(((' '+tbls[ti].className+' ').indexOf("serverTable") != -1)) {

                    // get table fixed header element
                    tblHeads = tbls[ti].getElementsByTagName("thead");
                    if(tblHeads.length > 0) {
                        // get header row
                        var headerRows = tblHeads[0].getElementsByTagName("tr");
                        if(headerRows.length > 0) {
                            rowcells = headerRows[0].getElementsByTagName("td");
                            rowcells[0].width = 30;
                            rowcells[1].width = tablewidth * (40/100);
                            rowcells[2].width = 120;
                            rowcells[3].width = 110;
                            rowcells[4].width = tablewidth * (20/100);
                            rowcells[5].width = 150;
                            rowcells[6].width = tablewidth * (40/100);
                            rowcells[7].width = 100;
                        }
                    }

                    // get table body element
                    tableBodies = tbls[ti].getElementsByTagName("tbody");
                    if(tableBodies.length > 0) {
                        tableBodies[0].style.height = (windowHeight - constheight) + "px";
                    }
                    break;
                }
            }
        }
        else if(((' '+divs[i].id+' ').indexOf("divHeader") != -1)) {
            divs[i].style.width = windowWidth + "px";
        }
        else if(((' '+divs[i].id+' ').indexOf("divFooter") != -1)) {
            divs[i].style.width = windowWidth + "px";
        }
    }
}

function buildServerInfoTable() {
    // Find all tables with class serverinfo
    if (!document.getElementsByTagName) return;

    // create server table element
    createTableElement();

    divs = document.getElementsByTagName("DIV");
    for(i = 0; i < divs.length; i++) {
        if(((' '+divs[i].className+' ').indexOf("tableContainer") != -1)) {
            // Take object table and get all it's tbodies.
            tbls = divs[i].getElementsByTagName("table");
            for(ti = 0; ti < tbls.length; ti++) {
                if(((' '+tbls[ti].className+' ').indexOf("serverTable") != -1)) {
                    // create table fixed header element
                    tblHeads = tbls[ti].getElementsByTagName("thead");
                    if(tblHeads.length == 0) {
                        newhead = document.createElement("thead");
                        newhead.className = "fixedHeader headerFormat";

                        // create fixed header row elements
                        newrow = document.createElement("tr");

                        createHeaderTDElement(newrow, "center", 30, "Num");
                        createHeaderTDElement(newrow, "left", tablewidth * (40/100), "FriendlyName");
                        createHeaderTDElement(newrow, "left", 120, "IP Address");
                        createHeaderTDElement(newrow, "left", 110, "MAC Address");
                        createHeaderTDElement(newrow, "left", tablewidth * (20/100), "Software Version");
                        createHeaderTDElement(newrow, "left", 150, "Configuration URL");
                        createHeaderTDElement(newrow, "center", tablewidth * (40/100), "Status");
                        createHeaderTDElement(newrow, "center", 100, "MAP Shares");

                        // appends the new row into fixed header element
                        newhead.appendChild(newrow);
                        // appends the new head element to the table
                        tbls[ti].appendChild(newhead);
                    }
                    // create table body element
                    tableBodies = tbls[ti].getElementsByTagName("tbody");
                    if(tableBodies.length == 0) {
                        newbody = document.createElement("tbody");
                        newbody.className = "serverEntry entryFormat";
                        newbody.style.height = (windowHeight - constheight) + "px";
                        tbls[ti].appendChild(newbody);
                    }
                    break;
                }
            }
        }
        if(((' '+divs[i].id+' ').indexOf("divHeader") != -1)) {
            divs[i].style.width = windowWidth + "px";
        }
        if(((' '+divs[i].id+' ').indexOf("divFooter") != -1)) {
            divs[i].style.width = windowWidth + "px";
        }
    }
}

function createTableElement() {
    divs = document.getElementsByTagName("DIV");
    for(i = 0; i < divs.length; i++) {
        if(((' '+divs[i].className+' ').indexOf("tableContainer") != -1)) {
            if(browser == "IE") {
                divs[i].style.height = (windowHeight - constheight) + "px";
            }
            // Take object table and get all it's tbodies.
            tables = divs[i].getElementsByTagName("table");
            if(tables.length == 0) {
                newtbl = document.createElement("table");
                newtbl.className = "serverTable";
                divs[i].appendChild(newtbl);
                tablewidth = windowWidth - constwidth;
                break;
            }
        }
    }
    return 0;
}

function createHeaderTDElement(row, align, width, innerhtml) {
    newcell = document.createElement("td");
    newcell.align = align;
    newcell.width = width;
    newcell.innerHTML = innerhtml;
    row.appendChild(newcell);
}

function createEntryTDElement(row, id, align, innerhtml) {
    newcell = document.createElement("td");
    newcell.setAttribute("id", id);
    newcell.setAttribute("align", align);
    newcell.innerHTML = innerhtml;
    row.appendChild(newcell);
}

/* **********************************************************
   *                                                        *
   * AddServerToList()                                      *
   *                                                        *
   * Add the new server entry into the serverTable table    *
   *                                                        *
   ********************************************************** */
function AddServerToList(sStatus, sIPAddress, sMACAddress, sFriendlyName, sFirmwareVersion, sConfigLocation) {
    // get the servertable's body
    tablebody = getServerTableBody();
    if(tablebody.length == 0)
        return;

    // increment the server count
    servercount++;

    newrow = document.createElement("tr");
    newrow.setAttribute("id", sMACAddress);

	sNASStatus = "Available";
	sSambaShareMap = "-"
	sConfigURL = '<a href="'+sConfigLocation+'" target="_blank">'+"Click to Configure NAS"+'</a>';
	if(sFirmwareVersion == "0") {
		sFirmwareVersion = "Zero-Disk";
	}
	else if(platform == "Windows") {
		// restrict MAP feature only to Windows platform
        sSambaShareMap = '<input type="button" value="Click to Map" onclick="doSambaSharesMapping(this);return true;">';
    }

    createEntryTDElement(newrow, "Num", "center", servercount);
    createEntryTDElement(newrow, "Name", "left", sFriendlyName);
    createEntryTDElement(newrow, "IPAddress", "left", sIPAddress);
    createEntryTDElement(newrow, "MACAddress", "left", sMACAddress);
    createEntryTDElement(newrow, "FWVersion", "left", sFirmwareVersion);
    createEntryTDElement(newrow, "ConfigURL", "left", sConfigURL);
    createEntryTDElement(newrow, "Status", "center", sNASStatus);

    // For MAP link
    newcell = document.createElement("td");
    newcell.setAttribute("id", "MAP");
    newcell.setAttribute("align", "center");
    newcell.innerHTML = sSambaShareMap;
    newcell.className = sMACAddress;
    newrow.appendChild(newcell);

    // appends the cell <td> into the row <tr>
    newrow.appendChild(newcell);

    // appends the new row into the existing table row
    tablebody[0].appendChild(newrow);
}

/* **********************************************************
   *                                                        *
   * RemoveNotAvailableServersFromList()                    *
   *                                                        *
   * Removes the NotAvailable servers entry row             *
   *                                                        *
   ********************************************************** */
function RemoveAllServersFromList() {
    // get the servertable's body
    tablebody = getServerTableBody();
    if(tablebody.length == 0)
        return;

	for (var i = 0; i < tablebody.length; i++) {
	    // Take the tbody, and get all it's rows
	    var tableRows = tablebody[i].getElementsByTagName("tr");
	    for(var j = tableRows.length-1; j >= 0; j--) {
			tablebody[i].removeChild(tableRows[j]);
			servercount--;
	    }
	    return;
	}
}

/* **********************************************************
   *                                                        *
   * UpdateServerToList()                                   *
   *                                                        *
   * Updates the server entry, to reflect the changes       *
   *                                                        *
   ********************************************************** */
function UpdateServerToList(sStatus, sIPAddress, sMACAddress, sFriendlyName, sFirmwareVersion, sConfigLocation, sReqType) {
    // get the servertable's body
    tablebody = getServerTableBody();
    if(tablebody.length == 0)
        return;
    var idx = 0;
    // Loop through these tbodies
    for (var i = 0; i < tablebody.length; i++) {
        // Take the tbody, and get all it's rows
        var tableRows = tablebody[i].getElementsByTagName("tr");
        for(var j = 0; j < tableRows.length; j++) {
            if(((' '+tableRows[j].id+' ').indexOf(sMACAddress) == -1)) {
                continue;
            }

            // skip updating entry, if upgrade is in progress
            clsname = tableRows[j].className;
            if((sReqType == "RESPONSE") && (clsname.length > 0) && (clsname.indexOf("UPGRADE") >= 0)) {
               	break;
            }
			tableRows[j].className = "";
			
			rowcell = tableRows[j].getElementsByTagName("td");

            // update "FriendlyName" column field
            rowcell[1].innerHTML = sFriendlyName;

            // update "IPAddress" column field
            rowcell[2].innerHTML = sIPAddress;

            // update "FirmwareVersion" column field
            if(sFirmwareVersion == "0") {
                rowcell[4].innerHTML = "Zero-Disk";
                sConfigURL = '<a href="'+sConfigLocation+'cgi-bin/raid/settings" target="_blank">'+"Click to Configure NAS"+'</a>';
            }
            else {
                rowcell[4].innerHTML = sFirmwareVersion;
                sConfigURL = '<a href="'+sConfigLocation+'" target="_blank">'+"Click to Configure NAS"+'</a>';
            }
//            sConfigURL = '<a href="'+sConfigLocation+'" target="_blank">'+"Click to Configure NAS"+'</a>';

            if(sStatus == "0") {
                rowcell[5].setAttribute("align", "center");

                // update the "ConfiguratorURL" column field
                rowcell[5].innerHTML = "-";

                // Update "Status" column field
                rowcell[6].innerHTML = "Not Available";

                // update "Map" column field
                rowcell[7].innerHTML = "-";
            }
            else if(sStatus == "1") {
                rowcell[5].setAttribute("align", "left");

                // update the "ConfiguratorURL" column field
                rowcell[5].innerHTML = sConfigURL;

                // Update "Status" column field
                rowcell[6].innerHTML = "Available";

                sSambaShareMap = "-"
                // restrict MAP feature only to Windows platform
    			if(sFirmwareVersion != "0" && platform == "Windows") {
                    sSambaShareMap = '<input type="button" value="Click to Map" onclick="doSambaSharesMapping(this);return true;">';
                }
                rowcell[7].innerHTML = sSambaShareMap;
            }
            tableRows[j].className = "";
            break;
        }
    }
}

function UpdateNASFirmwareUpgradeStatus(sMACAddress, sStatus) {
    // get the servertable's body
    tablebody = getServerTableBody();
    if(tablebody.length == 0)
        return;

    // Loop through these tbodies
    for (var i = 0; i < tablebody.length; i++) {
        // Take the tbody, and get all it's rows
        var tableRows = tablebody[i].getElementsByTagName("tr");
        for(var j = 0; j < tableRows.length; j++) {
            if(((' '+tableRows[j].id+' ').indexOf(sMACAddress) == -1)) {
                continue;
            }
            rowcell = tableRows[j].getElementsByTagName("td");
            
            if(tableRows[j].className == "") {
            	// update the "ConfiguratorURL" column field
	            rowcell[5].setAttribute("align", "center");
	            rowcell[5].innerHTML = "-";
	
	            // Update "MAP" column field
	            rowcell[7].innerHTML = "-";
	            tableRows[j].className = "UPGRADE";
            }

            rowcell[6].innerHTML = '<font color="red" size="2" face="Arial"><B>' + sStatus + '</B></font>';
            break;
        }
    }
}

/* **********************************************************
   *                                                        *
   * getServerTableBody()                                   *
   *                                                        *
   * Brings the serverTable body                            *
   *                                                        *
   ********************************************************** */
function getServerTableBody() {
    // Find all tables with class serverinfo
    if (!document.getElementsByTagName) return;

    var tableBodies;
    tbls = document.getElementsByTagName("table");
    for(ti = 0; ti < tbls.length; ti++) {
        if(((' '+tbls[ti].className+' ').indexOf("serverTable") != -1)) {
            // Take object table and get all it's tbodies.
            tableBodies = tbls[ti].getElementsByTagName("tbody");
            if(tableBodies.length == 0) {
                newbody = document.createElement("tbody");
                newbody.className = "serverEntry entryFormat";
                newbody.style.height = (windowHeight - constheight) + "px";
                tbls[ti].appendChild(newbody);
                // Take object table and get all it's tbodies.
                tableBodies = tbls[ti].getElementsByTagName("tbody");
            }
            break;
        }
    }
    return tableBodies;
}

function doSambaSharesMapping(link) {
    var macaddress = link.parentNode.className;
    // get the servertable's body
    tablebody = getServerTableBody();
    if(tablebody.length == 0)
        return;
    var idx = 0;
    var str;
    // Loop through these tbodies
    for (var i = 0; i < tablebody.length; i++) {
        // Take the tbody, and get all it's rows
        var tableRows = tablebody[i].getElementsByTagName("tr");
        for(var j = 0; j < tableRows.length; j++) {
            if(((' '+tableRows[j].id+' ').indexOf(macaddress) == -1)) {
                continue;
            }
            rowcell = tableRows[j].getElementsByTagName("td");

            // call applet function to invoke mapping
            document.NASDiscoveryApp.SetSambaShareMapFlag(rowcell[2].innerHTML);
            break;
        }
    }
}

function openBrowserPage(link) {
	newwin = window.open(link,'_blank');
}

function findString(userAgent, key) {
	return (userAgent.indexOf(key) + 1);
}
